乐筑天下

搜索
欢迎各位开发者和用户入驻本平台 尊重版权,从我做起,拒绝盗版,拒绝倒卖 签到、发布资源、邀请好友注册,可以获得银币 请注意保管好自己的密码,避免账户资金被盗
查看: 88|回复: 3

求助 VBA中坐标转换问题

[复制链接]

10

主题

21

帖子

5

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
61
发表于 2014-3-22 20:58:00 | 显示全部楼层 |阅读模式
以下是一段简单的vba程序代码
Sub Example_AddPolyline()
    ' This example creates a polyline in model space.
    Dim plineObj As AcadPolyline
    Dim points(0 To 14) As Double
    ' Define the 2D polyline points
    points(0) = 1: points(1) = 1: points(2) = 0
    points(3) = 1: points(4) = 2: points(5) = 0
    points(6) = 2: points(7) = 2: points(8) = 0
    points(9) = 3: points(10) = 2: points(11) = 0
    points(12) = 4: points(13) = 4: points(14) = 0
    ' Create a lightweight Polyline object in model space
    Set plineObj = ThisDrawing.ModelSpace.AddPolyline(points)
    ZoomAll
End Sub
上面的程序是在cad本身的世界坐标系下生成的一条多段线,现在本人在cad中通过ucs命令移动了坐标系的原点,请问怎么样修改上面的程序使其在自己定义的坐标系下生成所需要的这条多段线呢?
请高手多指教!!!
回复

使用道具 举报

0

主题

58

帖子

5

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
58
发表于 2014-3-23 11:37:00 | 显示全部楼层
第一种方法:将顶点坐标数组逐点由UCS转换为WCS,再画线
  1. Sub Example_AddPolyline()
  2.     ' This example creates a polyline in model space.
  3.     Dim plineObj As AcadPolyline
  4.     Dim points(0 To 14) As Double
  5.     ' Define the 2D polyline points
  6.     points(0) = 1: points(1) = 1: points(2) = 0
  7.     points(3) = 1: points(4) = 2: points(5) = 0
  8.     points(6) = 2: points(7) = 2: points(8) = 0
  9.     points(9) = 3: points(10) = 2: points(11) = 0
  10.     points(12) = 4: points(13) = 4: points(14) = 0
  11.    
  12.     Dim P1(2) As Double, P2 As Variant, I As Integer
  13.     For I = 0 To 12 Step 3
  14.         P1(0) = points(I): P1(1) = points(I + 1): P1(2) = points(I + 2)
  15.         P2 = ThisDrawing.Utility.TranslateCoordinates(P1, acUCS, acWorld, 0)
  16.         points(I) = P2(0): points(I + 1) = P2(1): points(I + 2) = P2(2)
  17.     Next
  18.     ' Create a lightweight Polyline object in model space
  19.     Set plineObj = ThisDrawing.ModelSpace.AddPolyline(points)
  20.     ZoomAll
  21. End Sub

第二种方法:先按WCS画线,再将其移动到UCS的相应位置.这种方法要求UCS要命名
  1. Sub Example_AddPolyline()
  2.     ' This example creates a polyline in model space.
  3.     Dim plineObj As AcadPolyline
  4.     Dim points(0 To 14) As Double
  5.     ' Define the 2D polyline points
  6.     points(0) = 1: points(1) = 1: points(2) = 0
  7.     points(3) = 1: points(4) = 2: points(5) = 0
  8.     points(6) = 2: points(7) = 2: points(8) = 0
  9.     points(9) = 3: points(10) = 2: points(11) = 0
  10.     points(12) = 4: points(13) = 4: points(14) = 0
  11.     ' Create a lightweight Polyline object in model space
  12.     Set plineObj = ThisDrawing.ModelSpace.AddPolyline(points)
  13.    
  14.     plineObj.TransformBy ThisDrawing.UserCoordinateSystems("UCS名称").GetUCSMatrix
  15.     ZoomAll
  16. End Sub
回复

使用道具 举报

10

主题

21

帖子

5

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
61
发表于 2014-3-26 20:26:00 | 显示全部楼层
谢谢高手的指点!能否直接points数组直接从WCS转换到UCS?
回复

使用道具 举报

6

主题

34

帖子

2

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
58
发表于 2014-4-18 10:32:00 | 显示全部楼层
占个位置,有时间学习
回复

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

  • 微信公众平台

  • 扫描访问手机版

  • 点击图片下载手机App

QQ|关于我们|小黑屋|乐筑天下 繁体中文

GMT+8, 2025-4-20 18:17 , Processed in 1.968243 second(s), 61 queries .

© 2020-2025 乐筑天下

联系客服 关注微信 帮助中心 下载APP 返回顶部 返回列表